﻿Public Class frmType37_7ChPushNotificationADC
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public SensorAddress As String
    Public Shared DataFrame As New NCDLib.Wireless.S3B_API.SensorData
    Public Shared Type37 As New NCDLib.Wireless.S3B_API.SensorData.TypeData.Type37
    Private Sub frmType37_7ChPushNotificationADC_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Text = "Type 37 7-Input Push Notification with Dual ADC - Address: " + SensorAddress
        Timer1.Interval = 10 '3000
        Timer1.Start()
    End Sub
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Timer1.Enabled = False  ' disable timer1
        BackgroundWorker1.RunWorkerAsync()
        Return
    End Sub
    Private Sub frmClose(sender As Object, e As EventArgs) Handles MyBase.Closed
        Timer1.Stop()
        BackgroundWorker1.CancelAsync()
        While BackgroundWorker1.IsBusy
            Application.DoEvents()
            Timer1.Stop()
        End While
    End Sub
    Private Sub BackgroundWorker1_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        'Receive Data from Wireless Sensor
        If BackgroundWorker1.CancellationPending = True Then Exit Sub
        Debug.Print("----------------------------------------------------------------------------------------------------------------------------Sensor Type DoWork Loop Start ------------ ")
        DataFrame = NCDLib.Wireless.S3B_API.SensorDataCapture(NCDComponent1, SensorAddress)
        Debug.Print(" ------------ DoWork Loop  Stop")
    End Sub
    Private Sub BackgroundWorker1_RunWorkerCompleted(sender As Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        Debug.Print("----------------------------------------------------------------------------------------------------------------------------Sensor Worker Finished ------------ ")
        'Parse Data
        If (DataFrame.Valid) Then
            Waiting.Visible = False
            BatteryLevel.Value = DataFrame.BatteryInt   'Show Battery Progress Bar
            Battery.Text = DataFrame.Battery            'Show Battery Voltage in Text Box
            NODEID.Text = DataFrame.NodeID              'Show Device Node ID Data
            Address.Text = SensorAddress                'Show Sensor Address
            Counter.Text = DataFrame.Counter.ToString   'Show Transmission Cycle Counter
            SensorType.Text = DataFrame.SensorType.ToString 'Show Sensor Type
            SensorInfo.Text = DataFrame.Description     'Show Sensor Description
            Firmware.Text = DataFrame.Firmware          'Show Firmware Version
            Summary.Text = DataFrame.SensorReadings     'Show a Summary View of All Sensor Data

            CompleteFrame.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompleteFrame)
            CompletePayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompletePayload)
            SensorPayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.SensorPayload)

            AllInputsDec.Text = Type37.AllInputs.ToString
            AllInputsBin.Text = NCDLib.Math.DecToBinaryString(Type37.AllInputs)
            IN1.Text = Type37.IN1.ToString
            IN2.Text = Type37.IN2.ToString
            IN3.Text = Type37.IN3.ToString
            IN4.Text = Type37.IN4.ToString
            IN5.Text = Type37.IN5.ToString
            IN6.Text = Type37.IN6.ToString
            IN7.Text = Type37.IN7.ToString
            Input1.Text = Type37.ADC1.ToString
            Input2.Text = Type37.ADC2.ToString
            Voltage1.Text = Type37.Voltage1.ToString + " V"
            Voltage2.Text = Type37.Voltage2.ToString + " V"

        End If
        Timer1.Enabled = True
    End Sub
End Class