﻿Public Class frmPR53_33
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public ScaleSetting As Integer = 0
    Public FormLoading As Boolean = True
    Public Multiplier As Decimal = 0.00164689 ' 0.00163961
    Private Sub frmPR53_33_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'MCP4728
        Dim I(15) As Byte
        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, 7616, 16)
        If I IsNot Nothing Then
            DAC1.Value = NCDLib.Safe.Limit_Value(NCDLib.Math.MSBLSB(I(0), I(1)), 0, 15250)
            DAC2.Value = NCDLib.Safe.Limit_Value(NCDLib.Math.MSBLSB(I(2), I(3)), 0, 15250)
            DAC3.Value = NCDLib.Safe.Limit_Value(NCDLib.Math.MSBLSB(I(4), I(5)), 0, 15250)
            DAC4.Value = NCDLib.Safe.Limit_Value(NCDLib.Math.MSBLSB(I(6), I(7)), 0, 15250)
            RAW1.Text = DAC1.Value.ToString
            Dim Value As Decimal = (DAC1.Value * Multiplier)
            Real1.Text = String.Format("{0:0.000}", Value) + "mA"
            RAW2.Text = DAC2.Value.ToString
            Value = (DAC2.Value * Multiplier)
            Real2.Text = String.Format("{0:0.000}", Value) + "mA"

            RAW3.Text = DAC3.Value.ToString
            Value = (DAC3.Value * Multiplier)
            Real3.Text = String.Format("{0:0.000}", Value) + "mA"

            RAW4.Text = DAC4.Value.ToString
            Value = (DAC4.Value * Multiplier)
            Real4.Text = String.Format("{0:0.000}", Value) + "mA"
        End If
        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, 7632, 16)
        If I IsNot Nothing Then 'Recovery Statup-State Options Drop Selection
            Recovery.SelectedIndex = NCDLib.Safe.Limit_Value(I(0), 0, 2)
        End If
        FormLoading = False
    End Sub
    Private Sub DAC1_Scroll(sender As Object, e As ScrollEventArgs) Handles DAC1.Scroll
        RAW1.Text = DAC1.Value.ToString
        Dim Value As Decimal = (DAC1.Value * Multiplier)
        Real1.Text = String.Format("{0:0.000}", Value) + "mA"
        NCDLib.Enterprise.Device.PR53_33.SetOutputs(NCDComponent1, 1, 1, DAC1.Value)
        GetTXRXData()
    End Sub
    Private Sub DAC2_Scroll(sender As Object, e As ScrollEventArgs) Handles DAC2.Scroll
        RAW2.Text = DAC2.Value.ToString
        Dim Value As Decimal = (DAC2.Value * Multiplier)
        Real2.Text = String.Format("{0:0.000}", Value) + "mA"
        NCDLib.Enterprise.Device.PR53_33.SetOutputs(NCDComponent1, 2, 2, DAC2.Value)
        GetTXRXData()
    End Sub
    Private Sub DAC3_Scroll(sender As Object, e As ScrollEventArgs) Handles DAC3.Scroll
        RAW3.Text = DAC3.Value.ToString
        Dim Value As Decimal = (DAC3.Value * Multiplier)
        Real3.Text = String.Format("{0:0.000}", Value) + "mA"
        NCDLib.Enterprise.Device.PR53_33.SetOutputs(NCDComponent1, 3, 3, DAC3.Value)
        GetTXRXData()
    End Sub
    Private Sub DAC4_Scroll(sender As Object, e As ScrollEventArgs) Handles DAC4.Scroll
        RAW4.Text = DAC4.Value.ToString
        Dim Value As Decimal = (DAC4.Value * Multiplier)
        Real4.Text = String.Format("{0:0.000}", Value) + "mA"
        NCDLib.Enterprise.Device.PR53_33.SetOutputs(NCDComponent1, 4, 4, DAC4.Value)
        GetTXRXData()
    End Sub

    Public Sub GetTXRXData()
        txtTransmitString.Text = NCDLib.GetLastTransmitString
        txtRecString.Text = NCDLib.GetLastReceivingString
        Me.Refresh()
    End Sub
    Private Sub Recovery_SelectedIndexChanged(sender As Object, e As EventArgs) Handles Recovery.SelectedIndexChanged
        If FormLoading = True Then Exit Sub
        Debug.Print("Selected item:" + Recovery.SelectedIndex.ToString)
        NCDLib.Enterprise.Device.PR53_33.StorePowerUpDefaultOptions(NCDComponent1, Recovery.SelectedIndex)
        GetTXRXData()
    End Sub
    Private Sub StorePowerupDefaultState_Click(sender As Object, e As EventArgs) Handles StorePowerupDefaultState.Click
        Recovery.SelectedIndex = 2
        If FormLoading = True Then Exit Sub
        NCDLib.Enterprise.Device.PR53_33.StorePowerUpDefaultOptions(NCDComponent1, Recovery.SelectedIndex)
        NCDLib.Enterprise.Device.PR53_33.StorePowerUpDefaultState(NCDComponent1, DAC1.Value, DAC2.Value, DAC3.Value, DAC4.Value)
        GetTXRXData()
    End Sub
End Class